---
title: Aggregate view
slug: Tools/Memory/Aggregate_view
---
<div>{{ToolsSidebar}}</div><p>Before Firefox 48, this was the default view of a heap snapshot. After Firefox 48, the default view is the <a href="/en-US/docs/Tools/Memory/Tree_map_view">Tree map view</a>, and you can switch to the Aggregate view using the dropdown labeled "View:":</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13028/memory-tool-switch-view.png" style="display: block; height: 270px; margin-left: auto; margin-right: auto; width: 716px;"></p>

<p>The Aggregate view looks something like this:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13030/memory-tool-aggregate-view.png" style="display: block; height: 267px; margin-left: auto; margin-right: auto; width: 716px;"></p>

<p>It presents a breakdown of the heap's contents, as a table. There are three main ways to group the data:</p>

<ul>
 <li>{{anch("Type")}}</li>
 <li>{{anch("Call Stack")}}</li>
 <li>{{anch("Inverted Call Stack")}}</li>
</ul>

<p>You can switch between them using the dropdown menu labeled "Group by:" located at the top of the panel:</p>

<p>There's also a box labeled "Filter" at the top-right of the pane. You can use this to filter the contents of the snapshot that are displayed, so you can quickly see, for example, how many objects of a specific class were allocated.</p>

<h2 id="Type">Type</h2>

<p>This is the default view, which looks something like this:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13030/memory-tool-aggregate-view.png" style="display: block; height: 267px; margin-left: auto; margin-right: auto; width: 716px;"></p>

<p>It groups the things on the heap into types, including:</p>

<ul>
 <li><strong>JavaScript objects:</strong> such as <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function">Function</a></code> or <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array">Array</a></code></li>
 <li><strong>DOM elements:</strong> such as <code><a href="/en-US/docs/Web/API/HTMLSpanElement">HTMLSpanElement</a></code> or <code><a href="/en-US/docs/Web/API/Window">Window</a></code></li>
 <li><strong>Strings:</strong> listed as <code>"strings"</code></li>
 <li><strong>JavaScript sources:</strong> listed as "<code>JSScript"</code></li>
 <li><strong>Internal objects:</strong> such as "<code>js::Shape</code>". These are prefixed with <code>"js::"</code>.</li>
</ul>

<p>Each type gets a row in the table, and rows are ordered by the amount of memory occupied by objects of that type. For example, in the screenshot above you can see that JavaScript <code>Object</code>s account for most memory, followed by strings.</p>

<ul>
 <li>The "Total Count" column shows you the number of objects of each category that are currently allocated.</li>
 <li>The "Total Bytes" column shows you the number of bytes occupied by objects in each category, and that number as a percentage of the whole heap size for that tab.</li>
</ul>

<div class="pull-aside">
<div class="moreinfo">The screenshots in this section are taken from a snapshot of the <a href="/en-US/docs/Tools/Memory/Monster_example">monster example page</a>.</div>
</div>

<p>For example, in the screenshot above, you can see that:</p>

<ul>
 <li>there are four <code>Array</code> objects</li>
 <li>that account for 15% of the total heap.</li>
</ul>

<p>Next to the type's name, there's an icon that contains three stars arranged in a triangle:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13054/memory-tool-in-group-icon.png" style="display: block; height: 136px; margin-left: auto; margin-right: auto; width: 496px;"></p>

<p>Click this to see every instance of that type. For example, the entry for <code>Array</code> tells us that there are four <code>Array</code> objects in the snapshot. If we click the star-triangle, we'll see all four <code>Array</code> instances:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13032/memory-tool-in-group.png" style="display: block; height: 267px; margin-left: auto; margin-right: auto; width: 716px;"></p>

<p>For each instance, you can see the <a href="/en-US/docs/Tools/Memory/Dominators#Shallow_and_retained_size">retained size and shallow size</a> of that instance. In this case, you can see that the first three arrays have a fairly large shallow size (5% of the total heap usage) and a much larger retained size (26% of the total).</p>

<p>On the right-hand side is a pane that just says "Select an item to view its retaining paths". If you select an item, you'll see the <a href="/en-US/docs/Tools/Memory/Dominators_view#Retaining_Paths_panel">Retaining paths panel</a> for that item:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13034/memory-tool-in-group-retaining-paths.png" style="display: block; height: 360px; margin-left: auto; margin-right: auto; width: 716px;"></p>


<p>{{EmbedYouTube("uLjzrvx_VCg")}}</p>

<h2 id="Call_Stack">Call Stack</h2>

<p>The Call Stack shows you exactly where in your code you are making heap allocations.</p>

<p>Because tracing allocations has a runtime cost, it must be explicitly enabled by checking "Record call stacks" <em>before</em> you allocate the memory in the snapshot.</p>

<p>You'll then see a list of all the functions that allocated objects, ordered by the size of the allocations they made:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13040/memory-tool-call-stack.png" style="display: block; height: 322px; margin-left: auto; margin-right: auto; width: 762px;"><br>
 <br>
 The structure of this view is very much like the structure of the <a href="/en-US/docs/Tools/Performance/Call_Tree">Call Tree</a>, only it shows allocations rather than processor samples. So, for example, the first entry says that:</p>

<ul>
 <li>4,832,592 bytes, comprising 93% of the total heap usage, were allocated in a function at line 35 of "alloc.js", <strong>or in functions called by that function</strong></li>
</ul>

<p>We can use the disclosure triangle to drill down the call tree, to find the exact place your code made those allocations.</p>

<p>It's easier to explain this with reference to a simple example. For this we'll use the <a href="/en-US/docs/Tools/Memory/DOM_allocation_example">DOM allocation example</a>. This page runs a script that creates a large number of DOM nodes (200 <code><a href="/en-US/docs/Web/API/HTMLDivElement">HTMLDivElement</a></code> objects and 4000 <code><a href="/en-US/docs/Web/API/HTMLSpanElement">HTMLSpanElement</a></code> objects).</p>

<p>Let's get an allocation trace:</p>

<ol>
 <li>open the Memory tool</li>
 <li>check "Record call stacks"</li>
 <li>load <a href="https://mdn.github.io/performance-scenarios/dom-allocs/alloc.html">https://mdn.github.io/performance-scenarios/dom-allocs/alloc.html</a></li>
 <li>take a snapshot</li>
 <li>select "View/Aggregate"</li>
 <li>select "Group by/Call Stack"</li>
</ol>

<p>{{EmbedYouTube("DyLulu9eoKY")}}</p>

<p>You should see something like this:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13040/memory-tool-call-stack.png" style="display: block; height: 322px; margin-left: auto; margin-right: auto; width: 762px;"></p>

<p>This is telling us that 93% of the total heap snapshot was allocated in functions called from "alloc.js", line 35 (our initial <code>createToolbars()</code> call).</p>

<p>We can use the disclosure arrow to expand the tree to find out exactly where we're allocating memory:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13042/memory-tool-call-stack-expanded.png" style="display: block; height: 530px; margin-left: auto; margin-right: auto; width: 762px;"></p>

<p>This is where the "Bytes" and "Count" columns are useful: they show allocation size and number of allocations at that exact point.</p>

<p>So in the example above, we can see that we made 4002 allocations, accounting for 89% of the total heap, in <code>createToolbarButton()</code>, at <a href="https://github.com/mdn/performance-scenarios/blob/gh-pages/dom-allocs/scripts/alloc.js#L9">alloc.js line 9, position 23</a>: that is, the exact point where we create the {{HTMLElement("span")}} elements.</p>

<p>The file name and line number is a link: if we click it, we go directly to that line in the debugger:</p>

<p>{{EmbedYouTube("zlnJcr1IFyY")}}</p>

<h2 id="Inverted_Call_Stack">Inverted Call Stack</h2>

<p>The Call Stack view is top-down: it shows allocations that happen at that point <strong>or points deeper in the call tree</strong>. So it's good for getting an overview of where your program is memory-hungry. However, this view means you have to drill a long way down to find the exact place where the allocations are happening.</p>

<p>The "Inverted Call Stack" view helps with that. It gives you the bottom-up view of the program showing the exact places where allocations are happening, ranked by the size of allocation at each place. The disclosure arrow then walks you back up the call tree towards the top level.</p>

<p>Let's see what the example looks like when we select "Inverted Call Stack":</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/13044/memory-tool-inverted-call-stack.png" style="display: block; height: 141px; margin-left: auto; margin-right: auto; width: 762px;"></p>

<p>Now at the top we can immediately see the <code>createToolbarButton()</code> call accounting for 89% of the heap usage in our page.</p>

<h2 id="(no_stack_available)">(no stack available)</h2>

<p>In the example above you'll note that 7% of the heap is marked "(no stack available)". This is because not all heap usage results from your JavaScript.</p>

<p>For example:</p>

<ul>
 <li>any scripts the page loads occupy heap space</li>
 <li>sometimes an object is allocated when there is no JavaScript on the stack. For example, DOM {{domxref("Event")}} objects are allocated before the JavaScript is run and event handlers are called.</li>
</ul>

<p>Many real-world pages will have a much higher "(no stack available)" share than 7%.</p>
